package ch.hepia;
import javax.json.*;
import java.io.*;

public class App {

  public App() {

    ClassLoader classLoader = getClass().getClassLoader();
    var url = classLoader.getResource("orders.json");
    File file = new File(url.getFile());
                            
    try(InputStream input = new FileInputStream(file)) {
      JsonReader reader = Json.createReader(input);
      JsonArray orders = reader.readArray();

      // List without duplicates :
      orders.stream() // Stream<JsonValue>
            .flatMap(
              o -> o.asJsonObject().getJsonArray("vendors").stream().map( v -> v.asJsonObject().getString("slug"))
            ) // Stream<String> (slugs)
            .distinct() // Stream<String> without duplicates
            .forEach(System.out::println); // void

    } catch (IOException e) {
      e.printStackTrace();
    }
  }
  public static void main(String[] args) {
    new App();
  }
}
